"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = function (_ref) {
  var template = _ref.template,
      t = _ref.types;
  var buildImport = template('Promise.resolve().then(() => MODULE)');
  return {
    inherits: _pluginSyntaxDynamicImport2["default"],
    visitor: {
      Import: function () {
        function Import(path) {
          var importArguments = path.parentPath.node.arguments;

          var _importArguments = _slicedToArray(importArguments, 1),
              importPath = _importArguments[0];

          var isString = t.isStringLiteral(importPath) || t.isTemplateLiteral(importPath);

          if (isString) {
            t.removeComments(importPath);
          }

          var SOURCE = isString ? importArguments : t.templateLiteral([t.templateElement({
            raw: '',
            cooked: ''
          }), t.templateElement({
            raw: '',
            cooked: ''
          }, true)], importArguments);
          var requireCall = t.callExpression(t.identifier('require'), [].concat(SOURCE));
          var _this$opts$noInterop = this.opts.noInterop,
              noInterop = _this$opts$noInterop === undefined ? false : _this$opts$noInterop;
          var MODULE = noInterop === true ? requireCall : t.callExpression(this.addHelper('interopRequireWildcard'), [requireCall]);
          var newImport = buildImport({
            MODULE: MODULE
          });
          path.parentPath.replaceWith(newImport);
        }

        return Import;
      }()
    }
  };
};

var _pluginSyntaxDynamicImport = require("@babel/plugin-syntax-dynamic-import");

var _pluginSyntaxDynamicImport2 = _interopRequireDefault(_pluginSyntaxDynamicImport);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

module.exports = exports["default"];